/*
 * LFNCall V 1.8
 *
 * Object Creater
 * (c) 1997-2002 Thomas Bohn, Vogelwiese 65, D-18435 Stralsund, Germany
 *
 */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
CALL RxFuncAdd 'FileLoadFuncs', 'FILEREXX', 'FileLoadFuncs' 
CALL FileLoadFuncs     

'@Echo off'
'cls'
say''
say'     Ŀ'
say'                                  LFNCall V 1.8                         '
say'                            (c) Thomas Bohn 1997-2002                   '
say'                   LFN-Objekt erzeugen / Create LFN object              '
say'     '
say''

say 'Bitte whlen Sie die Sprache. / Please select your language.'
say ''
say '(D)eutsch'
say '(E)nglish'
say ''
pull Spr
say ''
say ''
if Spr="D" then say 'Geben Sie einen Titel fr das Objekt (z.B. XYZApp-LFN) ein:'
if Spr="E" then say 'Type in a title of the application (ex. XYZApp-LFN):'
say ''
parse pull title
say ''
if length(title) > 0 then do
 if Spr="D" then say 'Geben Sie das Kommando fr die Anwendung mit vollstndigem Pfad ein:'
 if Spr="E" then say 'Type in the command of the application with full path:'
 say ''
 parse pull command
 say ''
 if length(command) > 0 then do
  if Spr="D" then say 'Geben Sie den Dateityp (z.B. *.XYZ) ein:'
  if Spr="E" then say 'Type in the file type (ex. *.XYZ):'
  say ''
  pull filetype
  say ''
  if length(filtype) > 0 then do
   if Spr="D" then do
    say 'Anwendungstyp:'
    say '  1 = Windows Fenster'
    say '  2 = DOS Fenster'
    say '  3 = DOS Vollbild'
   end
   if Spr="E" then do
    say 'Application type:'
    say '  1 = Windows seamless'
    say '  2 = DOS window'
    say '  3 = DOS fullscreen'
   end
   say ''
   parse upper pull wmode
   say ''
   if length(wmode) > 0 then do
    call ReadSetup 'LFNCALL.INI'
    Zaehler = SetupVar('CustApp')+1
    CustApp = 'CustApp'Zaehler
    assoc=SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype )
    Ende=length(assoc)-1
    assalt=substr(assoc,1,Ende)
    SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype, '00'x )
    classname = 'WPProgram'
    location = '<LFN_Folder>'
    select
     when wmode='1' then do
      Pfad = SetupVar('WinPath')
      setup = 'OBJECTID=<'title'>;EXENAME=LFN.EXE;STARTUPDIR='Pfad';MINWIN=HIDE;MINIMIZED=YES;PARAMETERS='command';ASSOCFILTER='filetype
     end
     when wmode='2' then do
      Pfad = SetupVar('DOSPath')
      setup = 'OBJECTID=<'title'>;EXENAME=LFD.EXE;STARTUPDIR='Pfad';MINWIN=HIDE;MINIMIZED=YES;PARAMETERS=D' command';ASSOCFILTER='filetype
     end
     when wmode='3' then do
      Pfad = SetupVar('DOSPath')
      setup = 'OBJECTID=<'title'>;EXENAME=LFD.EXE;STARTUPDIR='Pfad';MINWIN=HIDE;MINIMIZED=NO;PARAMETERS=F' command';ASSOCFILTER='filetype
     end
    end
    call SysCreateObject classname,title,location,setup,r
    call SysSleep 1
    assoc=SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype )
    Ende=length(assoc)-1
    assneu=substr(assoc,1,Ende)
    neutest=pos(assneu,assalt)
    if neutest <> 0 then assset = assalt || '00'x
    else assset = assneu || '00'x || assalt || '00'x
    Erg = SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype, assset )
    ok = SetupVar(CustApp,title)
    ok = SetupVar('CustApp',Zaehler)
    call WriteSetup
   end
  end
 end
end
if Spr="D" then say 'Fertig.'
if Spr="E" then say 'Ready.'
say ''
exit

/* TSETUP for Rexx */
/* V 1.6 (13.2.02) */

/* Beispiel Benutzung:
call ReadSetup 'LFNCALL.INI'       INI-File einlesen
say SetupVar( 'Mode' )             Wert anzeigen
Var = SetupVar( 'Mode' )           Wert in Variable bernehmen
Var = SetupVar( 'Mode', '/S' )     Wert auch bei gef. Teilstring bernehmen
ok = SetupVar('Mode','move')       Wert setzen
ok = SetupVar('App3','/L')         Key lschen
ok = SetupVar('App3','/D')         Key leer eintragen (Bsp.: App3=)
call WriteSetup                    INI-File schreiben
*/

ReadSetup:
 SetupDatei = ARG(1)
 if datatype(SetupKeys.0)='NUM' then do
  do i=1 to SetupKeys.0
   SetupKeys.i=''
   SetupStrings.i=''
  end
 end
 RSZ = 0
 handle = FileOpen(SetupDatei, 'r')
 do forever
  RSZ = RSZ+1
  Zeile = FileGets(handle)
  if FileErr = 0 then leave
  RSW = pos('=',Zeile)
  if RSW <> 0 then do
   SetupKeys.RSZ = strip(substr(Zeile,1,RSW-1),'B')
   SetupStrings.RSZ = strip(substr(Zeile,RSW+1),'B')
  end
  else do
   SetupKeys.RSZ = strip(Zeile,'B')
   SetupStrings.RSZ = ''
  end
 end
 ok = FileClose(handle)
 SetupKeys.0 = RSZ
 SetupStrings.0 = RSZ
return

SetupVar:
 Key = ARG(1)
 Inhalt = ARG(2)
 gefd = 0
 SVW = 0
 do SVZ = 1 to SetupKeys.0
  if gefd <> 1 then do
   if pos(translate(Key), translate(SetupKeys.SVZ)) == 1 then do
    if translate(Inhalt) = '/S' then do
     Ergebnis = strip( SetupStrings.SVZ, 'B' )
     gefd = 1
    end
    else
    if length(Key) == length(SetupKeys.SVZ) then do
     if Inhalt <> '' then do
      if translate(Inhalt) = '/L' then do
       SetupStrings.SVZ = ''
       SetupKeys.SVZ = '--/L--'
       SVW = SVW+1
      end
      if translate(Inhalt) = '/D' then do
       SetupStrings.SVZ = ''
      end
      else SetupStrings.SVZ = Inhalt
     end
     gefd = 1
     Ergebnis = strip( SetupStrings.SVZ, 'B' )
    end
   end
  end
 end
 Anzahl = SetupKeys.0-SVW
 if Inhalt <> '' then if gefd == 0 then do
  Anzahl = Anzahl+1
  SetupKeys.Anzahl = Key
  SetupStrings.Anzahl = Inhalt
  Ergebnis = strip( SetupStrings.Anzahl, 'B' )
 end
 if gefd == 0 then Ergebnis = ''
 SetupKeys.0=Anzahl
 SetupStrings.0=Anzahl
return Ergebnis

WriteSetup:
 WSZ = 0
 handle = FileOpen(SetupDatei, 'ws--', 'on')
 do while WSZ < SetupKeys.0
  WSZ=WSZ+1
  Zeile = SetupKeys.WSZ'='SetupStrings.WSZ
  if pos('SETUPKEYS',Zeile) == 0 then do
   if Zeile <> '=' then do
    if substr(Zeile,1,1) <> '[' then do
     if SetupKeys.WSZ <> '--/L--' then ok = FilePuts(handle,Zeile)
    end
    else ok = FilePuts(handle,SetupKeys.WSZ)
   end
   else ok = FilePuts(handle,'')
  end
 end
 ok = FileClose(handle)
return
